略微加速

略速 - 互联网笔记

mac OS X自带PHP环境,没有freetype的解决办法(imagefttext)

2020-04-15 11:12:15 leiting (439阅读)

标签 Mac OS PHP

最近用自己的电脑做个小东西,需要用到验证码,用的是thinkPHP框架,TP的验证码需要freetype库支持,MAC 的OS X自带APACHE和PHP,直接配置一下就可以使用,很方便,而且扩展支持也较多,挺方便的,但freetype没有,是个麻烦事,

其实本来也不麻烦,增加一个支持就可以了,如果在linux服务器环境下,都好办,或是自行编译的环境也好办,但就是因为使用的自带环境,又不想过多的改动系统 ,因为怕系统内有其他组件需要自带apache或是PHP支持,改了又会引起其他问题,所以就变得有 点麻烦了,网上大都都是一句话,重新编译PHP,增加freetype支持,但具体就没说了,这两天正好闲来无事,折腾了一下,搞定了,

我的思路是与PHP相关的东西,重新下载安装,这样不破坏原有环境,同时备份一下/usr/libexec/apache2/libphp5.so这个文件,并改名成libphp5-OX.so.然后在/etc/apache2/httpd.conf里增加一条:


#LoadModule php5_module        libexec/apache2/libphp5-OX.so

这样可以很方便的切换自带PHP和新编译的PHP


首先:

下载gd:

https://github.com/libgd/libgd/releases

libgd-2.1.1.tar.gz

需要png和jpeg,可以通过brew来安装 ,还有liftoff和libvpx库


brew install libpng

brew install libjpeg

brew install libtiff

 brew install libvpx

编译GD(注意看,使用brew安装的对应库位置,png jpeg等):

./configure --prefix=/usr/local/gd2 --with-zlib --with-png=/usr/local/opt/libpng --with-freetype=/usr/local/opt/freetype --with-jpeg=/usr/local/opt/jpeg/ --with-vpx=/usr/local/opt/libvpx/ --with-tiff=/usr/local/opt/libtiff/


然后从PHP官网上下载一个版本的PHP,可以与系统内的版本不一至,无所谓,

这里要注意的是,MAC系统有一个系统文件保护功能(SIP)是会将部分目录就连ROOT用户也无法访问,因为我们只想替换PHP,而并不替换APACHE,所以PHP在编译生成apache所需要的libphp5.so的时候,是需要将此文件放到/usr/libexec/apache2/目录下的,而这个目录是这被保护的,所有需要先把系统保护关掉,关闭步骤如下:

    1.重启MAC,按住command+R键,等看到MAC图标后松开

    2.启动进入Recovery Mode模式后,在菜单里面工具里找到终端(Terminal)打开,

    3.使用命令:csrutil disable;来关闭,然后reboot重启即可。

    以后如果要再启用,可以使用csrutil enable;即可。

然后

编译PHP

./configure --prefix=/usr/local/php/ --with-config-file-path=/usr/local/php/ --with-apxs2 --enable-sockets --enable-mbstring --with-bz2=shared --with-iconv=shared --with-mysql --with-gd-dir=/usr/local/gd2/  --with-pdo-mysql


在这里又遇到万恶的依赖关系统处理,首先是报:

'X11/xpm.h' file not found

按此提示,需要安装libXpm包,如下:

libXpm-3.5.5.tar.bz2  

但安装此包又会提示:

No package 'x11' found

No package 'xproto’ found

再安装:

libX11-1.5.0.tar.gz

和xproto这个包,

安装 X11的时候又会有一联串的依赖包,没办法,慢慢装

这里有个注意项

因为有太多的包,而这些包又是使用pkg-config来检查依赖关系的,所以需要安装pkg-config (这个也可以使用brew来安装,)

而pkg-config检查依赖关系是通过环境变量:PKG_CONFIG_PATH来检查对应包的pc文件的,所以我的处理方法是,所有安装这些包都放到一个目录下,然后配置环境变 量:

export PKG_CONFIG_PATH=/usr/local/xproto/lib/pkgconfig:/usr/lib/pkgconfig:/usr/local/lib/pkgconfig


接下来提示少哪个包,就去找对应的包,下载tar.gz格式的,

然后解压,

统一安装路径:

./configure —prefix=/usr/local/xproto

小提示:对应的包,大都都可以通过

lists.freedesktop.org

ftp://ftp.x.org/pub/X11R7.7/

这两个里面找到

不想费劲找的,我把我安装过程中下载的包统一打包放上来了,供大家下载,地址如下:


http://download.csdn.net/detail/sdomain/9432886




所有包都安装完成后,最终是把


libXpm-3.5.5.tar.bz2  

这个装上,

最后编译PHP,增加xpm扩展。


./configure --prefix=/usr/local/php/ --with-config-file-path=/usr/local/php/ --with-apxs2 --enable-sockets --enable-mbstring --with-bz2=shared --with-iconv=shared --with-mysql --with-gd=/usr/local/gd2/  --with-pdo-mysql --with-xpm-dir=/usr/local/xproto


configure没问题,但make时,提示gd.c文件找不到X11/xpm.h这个头文件,很奇怪,明明我指定了—with-xpm-path=/usr/local/xproto了,而这个路径下的include/X11/下面就有xpm.h这个文件,


把—with-xpm-path=/usr/local/xproto/include这么改,configure又通不过,

把gd.c里面的include路径改成include/X11/xpm.h也不行,

最后我把/usr/local/xproto/include下面的X11文件夹拷到PHP源代码下的ext/gd/文件夹下,编译没问题,make install也没问题,

我估计是path环境变量的问题,如果改$PATH增加一个/usr/local/xproto/include估计也可以,有兴趣的可以试试。

————————————————

原文链接:https://blog.csdn.net/sdomain/article/details/50673473


北京半月雨文化科技有限公司.版权所有 京ICP备12026184号